; MtApPack = Menuet Applications Packer
; Written by diamond in 2005,2006 specially for KolibriOS

; Uses aPLib compression library by Joergen Ibsen
; (for more information on aPLib visit http://www.ibsensoftware.com)

; Uses LZMA compression library by Igor Pavlov
; (for more information on LZMA and 7-Zip visit http://www.7-zip.org)
; (plain-C packer and ASM unpacker are ported by diamond)

	.486
	.model flat

GetCommandLineA		equ	__imp__GetCommandLineA@0
GetStdHandle		equ	__imp__GetStdHandle@4
WriteConsoleA		equ	__imp__WriteConsoleA@20
CreateFileA		equ	__imp__CreateFileA@28
GetFileSize		equ	__imp__GetFileSize@8
VirtualAlloc		equ	__imp__VirtualAlloc@16
ReadFile		equ	__imp__ReadFile@20
WriteFile		equ	__imp__WriteFile@20
CloseHandle		equ	__imp__CloseHandle@4
VirtualFree		equ	__imp__VirtualFree@12
ExitProcess		equ	__imp__ExitProcess@4

;includelib kernel32.lib
extrn GetStdHandle:dword
extrn GetCommandLineA:dword
extrn WriteConsoleA:dword
extrn CreateFileA:dword
extrn GetFileSize:dword
extrn VirtualAlloc:dword
extrn VirtualFree:dword
extrn ReadFile:dword
extrn WriteFile:dword
extrn CloseHandle:dword
extrn ExitProcess:dword

extrn _aP_pack:proc

lzma_compress equ _lzma_compress@16
lzma_set_dict_size equ _lzma_set_dict_size@4
extrn lzma_compress:proc
extrn lzma_set_dict_size:proc

.data?
infilename	dd	?
outfilename	dd	?
infile		dd	?
outfile1	dd	?
outfile2	dd	?
outfile		dd	?
outfilebest	dd	?
workmem		dd	?
insize		dd	?
outsize		dd	?
lzma_dictsize	dd	?
app_mem         dd      ?
app_esp         dd      ?
app_eip         dd      ?
app_i_param	dd	?
app_i_icon	dd	?
indelta		dd	?
cur_loader	dd	?
cur_loader_size	dd	?
used_calltrick_ptr	dd	?
used_calltrick_size	dd	?
params_ptr	dd	?
params_size	dd	?
path_ptr        dd      ?
path_size       dd      ?
ct1		db	256 dup (?)
ctn		dd	?
cti		db	?
intype          db      ?
loader_aplib	db	200 dup (?)

.const
info_str	db	'MtApPack - Menuet/Kolibri Applications Packer, version 2.2',13,10
		db	'Uses aPLib v0.43 compression library',13,10
		db	'Uses LZMA  v4.32 compression library',13,10,13,10
info_len	=	$ - offset info_str
usage_str	db	'Written by diamond in 2005-2006 specially for KolibriOS',13,10
		db	'aPLib compression library is copyright (c) 1998-2005 by Joergen Ibsen',13,10
		db	'LZMA  compression library is copyright (c) 1999-2005 by Igor Pavlov',13,10
		db	13,10
		db	'Usage: mtappack [-k] <infile> [<outfile>]',13,10
		db	'Valid switches:',13,10
		db	'-k  keep memory size (if possible); use this option, if you know that',13,10
		db	'    uninitialized app data may not be zeroed (as does system loader)',13,10
usage_len	=	$ - offset usage_str
errload_str	db	'Cannot load input file',13,10
errload_len	=	$ - offset errload_str
outfileerr_str	db	'Cannot save output file',13,10
outfileerr_len	=	$ - offset outfileerr_str
nomem_str	db	'No memory',13,10
nomem_len	=	$ - offset nomem_str
not_exe_str	db	'Not Menuet/Kolibri executable!',13,10
not_exe_len	=	$ - offset not_exe_str
too_big_str	db	'failed, output is greater than input.',13,10
too_big_len	=	$ - too_big_str
icon_wrn_str	db	"Warning: 'full path' field in header seems to be invalid and will be ignored.",13,10
icon_wrn_len	=	$ - icon_wrn_str
compressing_str	db	'Compressing ... '
compressing_len = $ - compressing_str

.data
done_str	db	'OK! Compression ratio: '
ratio		dw	'00'
		db	'%',13,10,13,10
done_len	=	$ - done_str

; Loader is located in the end of packed exe and consists from:
; 1. Unpacker code
; 2. (if calltrick is used) Calltrick restore code
; 3. (if command-line is used) Parameters restore code
; 4. (if path is used) Path restore code
; 5. (for size optimization) aPLib: getbit proc; LZMA: addresses of unpacker subroutines
; 6. Code to move packed data and unpacker to safe area
; entry points to part 6

loader_aplib_common label byte
	db	 00h, 00h, 00h, 00h, 01h, 0Ah, 00h, 00h, 00h, 00h,0D2h, 75h, 05h, 8Ah, 16h, 46h
	db	 10h,0D2h,0C3h, 6Ah, 34h, 5Fh,0B2h, 80h,0A4h,0B6h,0C1h,0FFh,0D3h, 73h,0F9h, 31h
	db	0C0h,0FFh,0D3h, 73h, 2Dh,0FFh,0D3h, 73h, 11h,0B6h,0C1h, 41h,0B0h, 10h,0FFh,0D3h
	db	 10h,0C0h, 73h,0FAh, 75h, 41h,0AAh, 49h,0EBh,0E1h,0ACh,0D1h,0E8h, 74h, 42h, 11h
	db	0C9h,0EBh, 2Dh, 79h, 2Eh, 83h,0D9h, 01h, 74h, 08h, 91h, 48h,0C1h,0E0h, 08h,0ACh
	db	0B6h, 00h, 41h,0FFh,0D3h, 11h,0C9h,0FFh,0D3h, 72h,0F8h, 00h,0F6h, 75h,0E4h, 3Dh
	db	 00h, 7Dh, 00h, 00h, 73h, 0Ah, 80h,0FCh, 05h, 73h, 06h, 83h,0F8h, 7Fh, 77h, 02h
	db	 41h, 41h, 95h, 89h,0E8h,0B6h, 41h, 56h, 89h,0FEh, 29h,0C6h,0F3h,0A4h, 5Eh,0EBh
	db	 9Ah
loader_aplib_common_size = $ - loader_aplib_common
aplib_size dd 78h
loader_lzma label byte
	db	 97h, 00h, 00h, 00h, 04h, 78h, 56h, 34h, 12h,0FFh,0FFh,0FFh,0FFh, 53h, 00h, 00h
	db	 00h, 00h, 00h, 00h, 00h, 52h, 8Bh, 53h,0F8h,0C1h,0EAh, 0Bh, 0Fh,0AFh, 10h, 39h
	db	 53h,0F4h, 73h, 18h, 89h, 53h,0F8h,0BAh, 00h, 08h, 00h, 00h, 2Bh, 10h,0C1h,0EAh
	db	 05h, 01h, 10h, 9Ch,0E8h, 13h, 00h, 00h, 00h, 9Dh, 5Ah,0C3h, 29h, 53h,0F8h, 29h
	db	 53h,0F4h, 8Bh, 10h,0C1h,0EAh, 05h, 29h, 10h,0F9h,0EBh,0E7h, 80h, 7Bh,0FBh, 00h
	db	 75h, 15h,0C1h, 63h,0F8h, 08h,0C1h, 63h,0F4h, 08h, 50h, 8Bh, 43h, 10h, 8Ah, 00h
	db	0FFh, 43h, 10h, 88h, 43h,0F4h, 58h,0C3h, 50h, 8Dh, 04h, 90h,0FFh, 13h, 58h,0C3h
	db	0B1h, 03h,0FFh, 13h, 73h, 1Ah, 83h,0C0h, 04h,0FFh, 13h, 72h, 08h, 8Dh, 54h,0D1h
	db	 7Eh, 6Ah, 08h,0EBh, 11h,0BAh, 01h, 01h, 00h, 00h,0B1h, 08h, 6Ah, 10h,0EBh, 06h
	db	0D3h,0E2h, 42h, 42h, 6Ah, 00h, 8Dh, 04h, 90h, 31h,0D2h, 42h, 51h,0FFh, 53h,0FCh
	db	 11h,0D2h,0E2h,0F9h, 59h, 0Fh,0BBh,0CAh, 59h, 01h,0D1h,0C3h, 31h,0EDh, 31h,0C0h
	db	 48h, 8Dh, 7Bh, 04h,0ABh,0ABh,0ABh, 96h,0ABh,0B5h, 20h,0B8h, 00h, 04h, 00h, 00h
	db	0BFh, 00h, 00h, 5Fh, 12h,0F3h,0ABh, 6Ah, 34h, 5Fh, 81h,0FFh, 50h, 41h, 52h, 45h
	db	 0Fh, 83h, 58h, 01h, 00h, 00h, 89h,0FAh, 83h,0E2h, 03h, 50h, 89h,0E8h,0C1h,0E0h
	db	 06h, 05h, 00h, 00h, 5Fh, 12h,0FFh, 53h,0FCh, 58h, 72h, 47h, 0Fh,0B6h,0C0h, 24h
	db	0E0h, 6Bh,0C0h, 60h, 05h,0D8h, 1Ch, 5Fh, 12h,0B2h, 01h, 83h,0FDh, 07h, 72h, 18h
	db	 8Ah, 0Ch, 37h, 00h,0C9h, 80h,0D6h, 01h,0FFh, 53h,0FCh, 10h,0D2h, 72h, 10h, 30h
	db	0D6h,0F6h,0C6h, 01h,0B6h, 00h, 75h,0EBh,0FFh, 53h,0FCh, 10h,0D2h, 73h,0F9h, 89h
	db	0E8h, 3Ch, 04h, 72h, 08h, 3Ch, 0Ah,0B0h, 03h, 72h, 02h,0B0h, 06h, 29h,0C5h, 92h
	db	0AAh,0EBh, 97h, 8Dh, 04h,0ADh, 00h, 03h, 5Fh, 12h,0FFh, 13h, 73h, 4Ch, 83h,0C0h
	db	 30h,0FFh, 13h, 72h, 1Dh, 89h,0E8h,0C1h,0E0h, 06h, 05h,0C0h, 03h, 5Fh, 12h,0FFh
	db	 53h,0FCh, 72h, 25h, 83h,0FDh, 07h, 19h,0EDh, 8Dh, 6Ch, 2Dh, 0Bh, 8Ah, 04h, 37h
	db	0EBh,0CEh, 83h,0C0h, 30h,0FFh, 13h, 87h, 73h, 04h, 73h, 0Dh, 83h,0C0h, 30h,0FFh
	db	 13h, 87h, 73h, 08h, 73h, 03h, 87h, 73h, 0Ch,0B8h,0D0h, 14h, 5Fh, 12h,0E8h,0EDh
	db	0FEh,0FFh,0FFh, 6Ah, 08h,0E9h, 8Eh, 00h, 00h, 00h, 87h, 73h, 04h, 87h, 73h, 08h
	db	 89h, 73h, 0Ch,0B8h,0C8h, 0Ch, 5Fh, 12h,0E8h,0D3h,0FEh,0FFh,0FFh, 6Ah, 03h, 5Ah
	db	 39h,0CAh, 72h, 02h, 89h,0CAh, 51h, 6Ah, 06h, 59h,0B8h,0C0h, 06h, 5Fh, 12h,0D3h
	db	0E2h,0E8h,0DEh,0FEh,0FFh,0FFh, 89h,0CEh, 83h,0F9h, 04h, 72h, 56h, 89h,0CAh, 31h
	db	0C0h,0D1h,0E9h, 14h, 02h, 49h,0D3h,0E0h, 89h,0C6h, 29h,0D0h, 8Dh, 04h, 85h,0BCh
	db	 0Ah, 5Fh, 12h, 83h,0FAh, 0Eh, 72h, 26h, 31h,0C0h,0D1h, 6Bh,0F8h, 01h,0C0h, 8Bh
	db	 53h,0F4h, 2Bh, 53h,0F8h, 72h, 05h, 89h, 53h,0F4h, 04h, 10h,0E8h, 5Bh,0FEh,0FFh
	db	0FFh, 49h, 83h,0F9h, 04h, 75h,0E3h, 01h,0C6h,0B8h, 88h, 0Ch, 5Fh, 12h, 57h, 31h
	db	0D2h, 42h, 89h,0D7h,0FFh, 53h,0FCh, 73h, 03h, 01h,0FEh,0F9h, 11h,0D2h, 01h,0FFh
	db	0E2h,0F2h, 5Fh, 59h,0F7h,0D6h, 6Ah, 07h, 83h,0FDh, 07h, 5Dh, 72h, 03h, 83h,0C5h
	db	 03h, 41h, 56h, 01h,0FEh,0F3h,0A4h,0ACh, 5Eh,0E9h, 02h,0FFh,0FFh,0FFh
lzma_size = 219h

calltrick db	 31h,0F6h,0B9h, 43h, 54h, 52h, 31h,0ACh, 2Ch,0E8h, 3Ch, 01h, 77h,0F9h, 80h, 3Eh
	db	 78h, 75h,0F4h,0ADh, 66h,0C1h,0E8h, 08h,0C1h,0C8h, 10h, 86h,0C4h, 29h,0F0h, 89h
	db	 46h,0FCh,0E2h,0E3h
calltrick_size = $ - calltrick
ctiptr1 = calltrick + 10h

calltrick2 db	 31h,0F6h,0B9h, 43h, 54h, 52h, 31h,0ACh, 3Ch, 0Fh, 75h, 09h,0ACh, 3Ch, 80h, 72h
	db	0F7h, 3Ch, 90h, 72h, 06h, 2Ch,0E8h, 3Ch, 01h, 77h,0ECh, 80h, 3Eh, 78h, 75h,0E7h
	db	0ADh, 66h,0C1h,0E8h, 08h,0C1h,0C8h, 10h, 86h,0C4h, 29h,0F0h, 89h, 46h,0FCh,0E2h
	db	0D6h
calltrick2_size = $ - calltrick2
ctiptr2 = calltrick2 + 1Dh

params_code db	 31h,0C0h,0B1h, 40h, 5Eh, 8Bh, 78h, 1Ch,0F3h,0A5h
params_code_len	= $ - params_code
path_code db     66h,0B9h, 00h, 01h, 31h,0C0h, 5Eh, 8Bh, 78h, 20h,0F3h,0A5h
path_code_len = $ - path_code

entry_code db	 6Ah, 24h, 5Eh,0BFh, 50h, 41h, 52h, 31h, 57h, 8Bh, 4Eh,0ECh,0F3h,0A4h, 5Eh, 8Dh
	db	 5Fh,0C1h,0E9h, 50h, 41h, 52h, 33h
entry_code_len = $ - entry_code

bForceMemInc db 1

use_aplib	=	1
use_lzma	=	2

use_no_calltrick =	0
use_calltrick1	=	10h
use_calltrick2	=	20h

method			db	1
bNeedStackRebase	db	0

.code

write_string:
	push	eax	; reserve dword on the stack
	mov	eax, esp
	push	ebx
	push	eax
	push	dword ptr [eax+12]
	push	dword ptr [eax+8]
	push	ebp
	call	[WriteConsoleA]
	pop	eax
	ret	8
write_exit:
	call	write_string
	push	ebx
	call	[ExitProcess]

_start:
; say hi to user
	xor	ebx, ebx
	push	eax	; reserve dword on the stack
	push	-11	; STD_OUTPUT_HANDLE
	call	[GetStdHandle]
	xchg	eax, ebp
	push	info_len
	push	offset info_str
	call	write_string
; parse command line
	call	[GetCommandLineA]
	xchg	eax, esi
	call	skip_spaces
	call	get_file_name
parse_options:
	call	skip_spaces
	cmp	al, '-'
	jnz	short parse_options_done
	inc	esi
	lodsb
	cmp	al, 'k'
	jnz	short usage
	mov	[bForceMemInc], 0
	jmp	parse_options
parse_options_done:
	test	al, al
	jz	short usage
	call	get_file_name
	mov	[infilename], edi
	test	al, al
	jnz	short two_files
	mov	[outfilename], edi
	jmp	short cont
usage:
	push	usage_len
	push	offset usage_str
	jmp	write_exit
two_files:
	call	get_file_name
	mov	[outfilename], edi
	test	al, al
	jnz	short usage
cont:
; Input file
	push	ebx
	push	ebx
	push	3	; OPEN_EXISTING
	push	ebx
	push	1	; FILE_SHARE_READ
	push	80000000h	; GENERIC_READ
	push	[infilename]
	call	[CreateFileA]
	inc	eax
	jnz	short inopened
infileerr:
	push	errload_len
	push	offset errload_str
	jmp	write_exit
inopened:
	dec	eax
	xchg	eax, esi
	push	ebx
	push	esi
	call	[GetFileSize]
	inc	eax
	jz	short infileerr
	dec	eax
	jz	short infileerr
	cmp	eax, 24h
	jbe	short infileerr
	mov	[insize], eax
	push	eax
	push	4	; PAGE_READWRITE
	push	1000h	; MEM_COMMIT
	push	eax
	push	ebx
	call	[VirtualAlloc]
	test	eax, eax
	jz	nomem
	mov	[infile], eax
	pop	edx
	mov	ecx, esp
	push	ebx
	push	ecx
	push	edx
	push	eax
	push	esi
	call	[ReadFile]
	test	eax, eax
	jz	short infileerr
	push	esi
	call	[CloseHandle]
	mov	esi, [infile]
	lodsd
	cmp	eax, 'UNEM'
	jnz	short not_menuet_exe
	lodsd
	bswap	eax
	sub	eax, 'ET00'
	cmp	eax, 1
	jz	short menuet01
	jb	short menuet00
not_menuet_exe:
	push	not_exe_len
	push	offset not_exe_str
	jmp	write_exit
menuet01:
        mov     eax, [esi+18h-8]
        mov     [app_esp], eax
	mov	eax, [esi+1Ch-8]
	mov	[app_i_param], eax
	mov	eax, [esi+20h-8]
	mov	[app_i_icon], eax
	mov     [intype], 1
; some stupid apps (such as 'desktop') begin from offset 0x20 and overwrite app_i_icon
	cmp	eax, [esi+14h-8]
	jb	short ok_sig
	push	icon_wrn_len
	push	offset icon_wrn_str
	call	write_string
	jmp	short zero_icon
menuet00:
	mov	eax, [esi+18h-8]
	mov	[app_i_param], eax
	mov     eax, [esi+14h-8]
	shr     eax, 1
	sub     eax, 10h
	mov     [app_esp], eax
	mov     [intype], 0
zero_icon:
	and	[app_i_icon], 0
ok_sig:
        mov     eax, [esi+0Ch-8]
        mov     [app_eip], eax
        mov     eax, [esi+14h-8]
        mov     [app_mem], eax
	mov	esi, offset loader_aplib_common
	mov	edi, offset loader_aplib
	mov	ecx, loader_aplib_common_size
	rep	movsb
; for small files make aPLib loader smaller
	mov	edi, offset loader_aplib + 5Fh
	mov	eax, [insize]
	cmp	eax, 65536
	ja	short aplib_no_modify
; <=65536 => modify 'cmp eax,32000' to 'cmp ah,32000/256'
; 3D 00 7D 00 00 -> 80 FC 7D
	inc	ecx
	inc     ecx
	mov	dword ptr [edi+1], 7DFC8000h
	cmp	eax, 32000
	ja	short aplib_do_modify
; <= 32000 => delete commands 'cmp eax,32000 / jae ...'
	mov	cl, 7
	cmp	eax, 500h
	ja	short aplib_do_modify
; <= 500h => delete commands 'cmp ah,5 / jae ...'
	mov	cl, 7+5
aplib_do_modify:
; delete ecx bytes from edi
	lea	esi, [ecx+edi]
	mov	edx, ecx
	push	edi
	neg	ecx
	add	ecx, loader_aplib_common_size - 5Fh
	rep	movsb
	sub	[aplib_size], edx
	pop	edi
; correct jumps
	mov	esi, offset loader_aplib
	mov	ecx, loader_aplib_common_size
	sub	ecx, edx
mjl:
	lodsb
	cmp	al, 0EBh
	jz	short mjjm
	cmp	al, 70h
	jb	short mjc
	cmp	al, 79h
	ja	short mjc
mjjm:
	lodsb
	movsx	eax, al
	add	eax, esi
	cmp	eax, edi
	jbe	short @f
	sub	eax, edx
@@:
	cmp	esi, edi
	jbe	short @f
	add	eax, edx
@@:
	sub	eax, esi
	mov	[esi-1], al
mjc:
	loop	mjl
aplib_no_modify:
	mov	eax, [insize]
	shr	eax, 3
	add	eax, [insize]
	add	eax, 400h	; should be enough for header + unpacker code
	mov	esi, eax
	add	eax, eax
	push	4
	push	1000h
	push	eax
	push	ebx
	call	[VirtualAlloc]
	test	eax, eax
	jnz	short outmemok
nomem:
	push	nomem_len
	push	offset nomem_str
	jmp	write_exit
outmemok:
	mov	[outfile], eax
	mov	[outfile1], eax
	mov	[outfilebest], eax
	add	eax, esi
	mov	[outfile2], eax
	sub	eax, esi
	mov	dword ptr [eax], 'UNEM'
	mov	dword ptr [eax+4], '10TE'
	mov	dword ptr [eax+8], 1
	mov	ecx, 12
	mov	edi, eax
	mov	esi, [infile]
	repz	cmpsb
	jz	@f
	dec	edi
@@:	sub	edi, eax
	mov	eax, edi
	mov	[indelta], eax
	mov	ecx, [insize]
	sub	ecx, eax
	dec	ecx
	bsr	eax, ecx
	inc	eax
	cmp	eax, 28
	jb	short @f
	mov	eax, 28
@@:
	push	eax
	push	eax
	call	lzma_set_dict_size
	pop	ecx
	mov	eax, 1
	shl	eax, cl
	mov	[lzma_dictsize], eax
	imul	eax, 19
	shr	eax, 1
	add	eax, 509000h
	push	4
	push	1000h
	push	eax
	push	ebx
	call	[VirtualAlloc]
	test	eax, eax
	jz	nomem
	mov	[workmem], eax
	push	compressing_len
	push	offset compressing_str
	call	write_string
	or      [outsize], -1
	cmp     word ptr [insize+2], 0
	jnz     short @f
	call	pack_aplib
	add	eax, [aplib_size]
	mov	[outsize], eax
@@:
	mov	eax, [outfile2]
	mov	[outfile], eax
	xchg	eax, edi
	mov	esi, [outfile1]
	movsd
	movsd
	movsd
	call	pack_lzma
	add	eax, lzma_size
	cmp	eax, [outsize]
	jae	short @f
	mov	[outsize], eax
	mov	eax, [outfile]
	mov	[outfilebest], eax
	mov	[method], use_lzma
@@:
	call	preprocess_calltrick
	test	eax, eax
	jz	short noct1
	call	set_outfile
	cmp     word ptr [insize+2], 0
	jnz     short @f
	call	pack_aplib
	add	eax, calltrick_size
	add	eax, [aplib_size]
	cmp	eax, [outsize]
	jae	short @f
	mov	[outsize], eax
	mov	eax, [outfile]
	mov	[outfilebest], eax
	mov	[method], use_aplib or use_calltrick1
@@:
	call	set_outfile
	call	pack_lzma
	add	eax, calltrick_size + lzma_size
	cmp	eax, [outsize]
	jae	short @f
	mov	[outsize], eax
	mov	eax, [outfile]
	mov	[outfilebest], eax
	mov	[method], use_lzma or use_calltrick1
@@:
noct1:
	call	set_outfile
	push	[ctn]
	mov	al, [cti]
	push	eax
	call	preprocess_calltrick2
	test	eax, eax
	jz	noct2
	cmp     word ptr [insize+2], 0
	jnz     short @f
	call	pack_aplib
	add	eax, calltrick2_size
	add	eax, [aplib_size]
	cmp	eax, [outsize]
	jae	short @f
	mov	[outsize], eax
	mov	eax, [outfile]
	mov	[outfilebest], eax
	mov	[method], use_aplib or use_calltrick2
	pop	ecx
	pop	ecx
	push	[ctn]
	mov	al, [cti]
	push	eax
@@:
	call	set_outfile
	call	pack_lzma
	add	eax, calltrick2_size + lzma_size
	cmp	eax, [outsize]
	jae	short @f
	mov	[outsize], eax
	mov	eax, [outfile]
	mov	[outfilebest], eax
	mov	[method], use_lzma or use_calltrick2
	pop	ecx
	pop	ecx
	push	[ctn]
	mov	al, [cti]
	push	eax
@@:
noct2:
	pop	eax
	mov	[cti], al
	pop	[ctn]
	mov	esi, offset calltrick+2
	mov	ecx, calltrick_size
	test	[method], use_calltrick1
	jnz	short @f
	mov	esi, offset calltrick2+2
	mov	ecx, calltrick2_size
	test	[method], use_calltrick2
	jz	short pack_common
@@:
	sub	[outsize], ecx
; modify calltrick loader
	mov	eax, [ctn]
	cmp	eax, 0FFFFh
	ja	short ctml1
	cmp	eax, 0FFh
	ja	short ctml2
; mov ecx,xx -> mov cl,xx
	sub	ecx, 3
	add	esi, 3
	mov	byte ptr [esi], 0B1h
	mov	[esi+1], al
	jmp	short ctml3
ctml2:
; mov ecx,xx -> mov cx,xx
	dec	ecx
	inc	esi
	mov	word ptr [esi], 0B966h
	mov	[esi+2], ax
	jmp	short ctml3
ctml1:
	mov	[esi+1], eax
ctml3:
; after aPLib unpacker eax=0
	test	[method], use_aplib
	jnz	short ctml4
	dec	esi
	dec	esi
	mov	word ptr [esi], 0F631h	; xor esi,esi
	jmp	short ctml5
ctml4:
	dec	esi
	dec	ecx
	mov	byte ptr [esi], 96h	; xchg eax,esi
ctml5:
	mov	[used_calltrick_ptr], esi
	mov	[used_calltrick_size], ecx
	mov	al, [cti]
	mov	[ctiptr1], al
	mov	[ctiptr2], al
pack_common:
	mov	[cur_loader], offset loader_lzma
	mov	eax, lzma_size
	test	[method], use_aplib
	jz	short @f
	mov	[cur_loader], offset loader_aplib
	mov	eax, [aplib_size]
@@:
	sub	[outsize], eax
	mov	[cur_loader_size], eax
; path
        and     [path_ptr], 0
        and     [path_size], 0
        cmp     [app_i_icon], 0
        jz      short nph1
        mov     esi, offset path_code
        mov     ecx, path_code_len
; after aPLib unpacker code eax=ecx=0
; after LZMA unpacker code ecx=000000xx
; after calltrick preprocessing ecx=0
; after parameters restore eax=ecx=0
        cmp     [app_i_param], 0
        jnz     ph1
        cmp     [method], use_aplib
        jnz     short @f
ph1:
; there is cmdline or we use aplib w/o calltrick
; it is safe to delete 'xor eax,eax'
        lodsd
        dec     esi
        dec     esi
        mov     [esi], eax
        dec     ecx
        dec     ecx
@@:
        cmp     [app_i_param], 0
        jnz     ph2
        cmp     [method], use_lzma
        jz      short @f
ph2:
; there is cmdline or we don't use lzma w/o calltrick
; it is safe to replace 'mov cx,100' -> 'mov ch,1'
	inc	esi
	inc	esi
	dec	ecx
	dec	ecx
	mov	word ptr [esi], 01B5h
@@:
        mov     [path_ptr], esi
        mov     [path_size], ecx
nph1:
; parameters
	and	[params_ptr], 0
	and	[params_size], 0
	cmp	[app_i_param], 0
	jz	short npl1
	mov	esi, offset params_code
	mov	ecx, params_code_len
; after aPLib unpacker code eax=ecx=0
; after LZMA unpacker code ecx=000000xx
; after calltrick preprocessing ecx=0
; so for aPLib w/o calltrick we may delete instruction 'xor eax,eax'
	cmp	[method], use_aplib
	jnz	short @f
	inc     esi
	inc     esi
	dec	ecx
	dec	ecx
@@:
	mov	[params_ptr], esi
	mov	[params_size], ecx
npl1:
	mov	eax, [outsize]
	add	eax, 24h
	add	eax, [cur_loader_size]
	test	[method], use_calltrick1 or use_calltrick2
	jz	short npl2
	add	eax, [used_calltrick_size]
	cmp	[cti], 1
	ja	short npl2
	jz	short npl3
	dec	eax
npl3:
	dec	eax
npl2:
	add	eax, [params_size]
	add     eax, [path_size]
	cmp     [app_i_param], 0
	jz      short @f
	cmp     [app_i_icon], 0
	jz      short @f
	dec     eax
@@:
        cmp     [app_i_param], 0
        jz      short npl4
        add     eax, 3
        jmp     short @f
npl4:
        cmp     [app_i_icon], 0
        jz      short @f
        inc     eax
        inc     eax
@@:
	add	eax, 3+5
	cmp	[method], use_lzma
	jnz	short @f
	cmp	[app_i_param], 0
	jnz	short @f
	cmp     [app_i_icon], 0
	jnz     short @f
	inc	eax
	inc	eax
@@:
	test	[method], use_aplib
	jnz	short @f
	mov	ecx, [cur_loader]
	movzx	ecx, byte ptr [ecx+4]
	lea	eax, [eax+ecx*4]
@@:	mov	esi, eax
	add	eax, entry_code_len
	cmp	eax, [insize]
	jb	short packed_ok
	push	too_big_len
	push	offset too_big_str
	jmp	write_exit
packed_ok:
	push	eax
	push	8000h	; MEM_RELEASE
	push	ebx
	push	[workmem]
	call	[VirtualFree]
	pop	eax
; set header
	mov	edi, [outfilebest]
	mov	[edi+12], esi		; app_start
	mov	[edi+16], eax		; app_i_end
	mov	ecx, [app_mem]
	mov	[edi+20], ecx		; app_mem
	mov     ecx, [app_esp]
	mov     [edi+24], ecx           ; app_esp
	and	dword ptr [edi+28], 0   ; app_i_param (to be filled)
	and	dword ptr [edi+32], 0	; app_i_icon (to be filled)
; find destination memory
	cmp	[app_i_param], 0
	jz	short @f
	add	eax, 256
@@:
        cmp     [app_i_icon], 0
        jz      short @f
        add     eax, 1024
@@:
; LZMA unpacker needs some (uninitialized) memory
	push	eax
	test	[method], use_lzma
	jz	short @f
	add	eax, 8000h +3+3
@@:
; we need eax bytes of additional memory
; memory map: (inclusive..exclusive)
; 0..[insize] : here will be unpacked output
; esp-30h..esp : stack (note that if it intercepts with 1st region, loader stack must be changed)
; if command line is used: app_i_param..app_i_param+100h : parameters
; if path is used: app_i_icon..app_i_icon+400h : path
	mov	ecx, [edi+24]
	sub	ecx, 30h
	mov	edx, [app_i_param]
	add	edx, 100h
	cmp	edx, [insize]
	ja	short @f
	mov	edx, [insize]
@@:	sub	ecx, edx
	jae	short @f
; hmm... probably this is @rcher or similar app, and stack is between main code and params?
	add	ecx, edx
	cmp	ecx, [insize]
	jb	short stack_err
	mov	ecx, [edi+24]
	cmp	ecx, [app_i_param]
	jbe	short place_mem_test1
stack_err:
	mov	[bNeedStackRebase], 1
	add	eax, 30h
	mov	edx, [app_i_param]
	add	edx, 100h
	cmp	edx, [insize]
	ja	short place_mem_test1
	mov	edx, [insize]
	jmp	short place_mem_test1
@@:
	cmp	[bForceMemInc], 0
	jz	short @f
place_mem_test2:
	mov	edx, [edi+20]
	jmp	short place_mem_test
place_mem_test1:
	cmp	[bForceMemInc], 0
	jz	short place_mem_test
	jnz	place_mem_test2
@@:
	cmp	ecx, eax
	jae	short place_found
; if no place between (file+parameters) and stack, then use high location - after stack
	mov	edx, [edi+24]
; probably we need to increase memory size?
place_mem_test:
	lea	ecx, [eax+edx]
	cmp	ecx, [edi+20]
	jbe	short place_found
	mov	[edi+20], ecx
place_found:
; edx contains additional place
	mov	esi, 5
	cmp	[bNeedStackRebase], 0
	jz	short pfnsr
	and	ecx, not 3	; make esp dword-aligned
	mov	[edi+24], ecx
	cmp     [intype], 0
	jz      short pfcmn
	mov	esi, 2
pfnsr:
	sub	[edi+12], esi
	sub	[edi+16], esi
	sub	[esp], esi
pfcmn:
        mov     eax, edx
        add     eax, [edi+16]
        cmp     [app_i_param], 0
        jz      short @f
        mov     [edi+28], eax
        add     eax, 256
@@:
        cmp     [app_i_icon], 0
        jz      short @f
        mov     [edi+32], eax
@@:

; setup loader
	add	edi, 24h
	add	edi, [outsize]
	mov	ecx, [cur_loader_size]
	mov	esi, [cur_loader]
	add	esi, 4
	xor	eax, eax
	lodsb
	lea	esi, [esi+eax*4]
	push	edi
	test	[method], use_aplib
	jz	short @f
	sub	ecx, [esi-4]
	add	esi, [esi-4]
@@:
	rep	movsb
	and	dword ptr [edi], 0
	xchg	edi, [esp]
	mov	al, byte ptr [indelta]
	test	[method], use_lzma
	jnz	short lzma_loader_set
	mov	[edi+1], al
	jmp	short aplib_loader_set
lzma_loader_set:
	mov	[edi+0B3h], al
	mov	eax, [insize]
	mov	[edi+0B7h], eax
	mov	eax, [esp+4]
	sub	eax, 125F0000h
	add	eax, edx
	add	eax, 3+3
	and	al, not 3
@@:
	cmp	dword ptr [edi], 125F0000h
	jb	short llsc
	cmp	dword ptr [edi], 125F8000h
	jae	short llsc
	add	[edi], eax
	add	edi, 3
llsc:
	inc	edi
	cmp	edi, [esp]
	jb	short @b
aplib_loader_set:
	pop	edi
	pop	ecx
	test	[method], use_calltrick1 or use_calltrick2
	jz	short @f
	mov	esi, [used_calltrick_ptr]
	mov	ecx, [used_calltrick_size]
	sub	ecx, 10h
	rep	movsb
	cmp	[cti], 1
	jb	short als0
	jz	short als1
	movsd
	jmp	short als2
als1:
; 'shr ax,8' -> 'dec eax/xchg al,ah'
	mov	al, 48h
	stosb
	dec	byte ptr [esi+0Fh]
als0:
; 'shr ax,8' -> 'xchg al,ah'
	mov	ax, 0C486h
	stosw
	add	byte ptr [esi+0Fh], 2
	add	esi, 4
als2:
	mov	ecx, 0Ch
	rep	movsb
@@:
	cmp	[app_i_param], 0
	jz	short @f
	mov	esi, [params_ptr]
	mov	ecx, [params_size]
	rep	movsb
	cmp     [intype], 0
	jnz     short @f
	mov	byte ptr [edi-3], 18h
@@:
        cmp     [app_i_icon], 0
        jz      short noicon
        mov     esi, [path_ptr]
        mov     ecx, [path_size]
        sub     ecx, 5
        rep     movsb
;        cmp     [app_i_param], 0
;        jz      short @f
;        dec     edi
;@@:
        cmp     [app_i_param], 1
        adc     edi, 0
        dec     edi
        movsd
        movsb
noicon:
	cmp	[method], use_lzma
	jnz	short @f
	cmp	[app_i_param], 0
	jnz	short @f
	cmp     [app_i_icon], 0
	jnz     short @f
	mov	ax, 0C931h	; 31 C9 = xor ecx,ecx
	stosw
@@:
	cmp	[bNeedStackRebase], 0
	jz	short no_stack_rebase
	cmp     [intype], 0
	jz	short stack0_rebase
; mov esp,[ecx+18h] = 8B 61 18
	mov	ax, 618Bh
	stosw
	mov	al, 18h
	stosb
	jmp	short no_stack_rebase
stack0_rebase:
; mov esp,xxxxxxxx = BC xxxxxxxx
	mov	al, 0BCh
	stosb
	mov     eax, [app_esp]
	stosd
no_stack_rebase:
; jmp [ecx+0xC] = FF 61 0C
	mov	ax, 61FFh
	stosw
	mov	al, 0Ch
	stosb
	mov	esi, [cur_loader]
	add	esi, 4
	xor	eax, eax
	lodsb
	xchg	eax, ecx
	test	[method], use_lzma
	jz	short apli1
	mov	eax, edi
	sub	eax, [outfilebest]
	add	eax, edx
	and	eax, 3
	jz	short aligned
	sub     eax, 4
	neg     eax
	add     edx, eax
	push    edi
	mov     edi, [outfilebest]
	cmp     dword ptr [edi+28], 0
	jz      @f
	add     [edi+28], eax
@@:
        cmp     dword ptr [edi+32], 0
        jz      @f
        add     [edi+32], eax
@@:
        mov     edi, [params_ptr]
        test    edi, edi
        jz      @f
        add     [edi-9], eax
@@:
        pop     edi
aligned:
	movsd
	movsd
	dec	ecx
	dec	ecx
@@:
	lodsd
	add	eax, edx
	add	eax, [outsize]
	stosd
	loop	@b
	jmp	short apli2
apli1:
	lodsd
	xchg	eax, ecx
	rep	movsb
apli2:
; entry code
	mov	esi, offset entry_code
	mov	ecx, entry_code_len
	push	edi
	rep	movsb
	pop	edi
	mov	[edi+4], edx
	mov	ecx, [outfilebest]
	mov	eax, [cur_loader]
	mov	eax, [eax]
	add	eax, edx
	add	eax, [outsize]
	sub	eax, edi
	sub	eax, entry_code_len
	add	eax, [outfilebest]
	mov	[edi+13h], eax
	test	[method], use_aplib
	jz	short @f
	mov	byte ptr [edi+11h], 0BBh
@@:
        mov     ecx, entry_code_len - 3
        mov     eax, [outfilebest]
        cmp     [app_i_param], 0
        jz      short entry_no_param
        lea     esi, [edi+entry_code_len-1]
        lea     edi, [esi+3]
        std
        rep     movsb
        cld
        mov     byte ptr [edi], 0F8h
        mov     word ptr [edi-2], 76FFh
        sub     byte ptr [edi+15], 3
        sub     dword ptr [edi+17], 3
        sub     dword ptr [eax+12], 3
        jmp     entry_setup_done
entry_no_param:
        cmp     [app_i_icon], 0
        jz      entry_setup_done
        lea     esi, [edi+entry_code_len-1]
        lea     edi, [esi+2]
        std
        rep     movsb
        cld
        mov     byte ptr [edi-3], 20h
        mov     word ptr [edi-1], 50ADh
        sub     byte ptr [edi+15], 2
        sub     dword ptr [edi+17], 2
        sub     dword ptr [eax+12], 2
entry_setup_done:
        mov     edi, eax
	mov	eax, [edi+16]
	mov	ecx, 100
	mul	ecx
	div	[insize]
	aam
	xchg	al, ah
	add	ax, '00'
	mov	[ratio], ax
	push	done_len
	push	offset done_str
	call	write_string
; Output file
	push	ebx
	push	80h	; FILE_ATTRIBUTE_NORMAL
	push	2	; CREATE_ALWAYS
	push	ebx
	push	ebx
	push	40000000h	; GENERIC_WRITE
	push	[outfilename]
	call	[CreateFileA]
	inc	eax
	jnz	short @f
outerr:
	push	outfileerr_len
	push	offset outfileerr_str
	jmp	write_exit
@@:
	dec	eax
	xchg	eax, esi
	mov	eax, esp
	push	ebx
	push	eax
	push	dword ptr [edi+16]
	push	edi
	push	esi
	call	[WriteFile]
	test	eax, eax
	jz	short outerr
	push	esi
	call	[CloseHandle]
	push	ebx
	call	[ExitProcess]

get_file_name:
	mov	edi, esi
	lodsb
	cmp	al, 0
	jz	short _ret
	cmp	al, '"'
	setz	dl
	jz	short @f
	dec	esi
@@:	mov	edi, esi
@@loop:
	lodsb
	cmp	al, 0
	jz	short _ret
	cmp	al, ' '
	ja	short @f
	test	dl, 1
	jz	short @@end
@@:
	cmp	al, '"'
	jnz	short @@loop
	test	dl, 1
	jz	short @@loop
@@end:
	mov	byte ptr [esi-1], 0

skip_spaces:
	lodsb
	cmp	al, 0
	jz	short @f
	cmp	al, ' '
	jbe	short skip_spaces
@@:
	dec	esi
_ret:
	ret

set_outfile:
	mov	eax, [outfilebest]
	xor	eax, [outfile1]
	xor	eax, [outfile2]
	mov	[outfile], eax
	ret

pack_calltrick_fail:
	xor	eax, eax
	xor	ebx, ebx
	mov	[ctn], eax
	ret
preprocess_calltrick:
; input preprocessing
	push	4	; PAGE_READWRITE
	push	1000h	; MEM_COMMIT
	push	[insize]
	push	ebx
	call	[VirtualAlloc]
	test	eax, eax
	jz	pack_calltrick_fail
	push	eax
	xor	eax, eax
	mov	edi, offset ct1
	mov	ecx, 256/4
	push	edi
	rep	stosd
	pop	edi
	mov	ecx, [insize]
	mov	esi, [infile]
	xchg	eax, edx
	pop	eax
	xchg	eax, ebx
	push	ebx
input_pre:
	lodsb
	sub	al, 0E8h
	cmp	al, 1
	ja	short input_pre_cont
	cmp	ecx, 5
	jb	short input_pre_done
	lodsd
	add	eax, esi
	sub	eax, [infile]
	cmp	eax, [insize]
	jae	short xxx
	cmp	eax, 1000000h
	jae	short xxx
	sub	ecx, 4
	bswap	eax
	mov	[esi-4], eax
	inc	edx
	mov	[ebx], esi
	add	ebx, 4
	jmp	short input_pre_cont
xxx:	sub	esi, 4
	movzx	eax, byte ptr [esi]
	mov	byte ptr [eax+edi], 1
input_pre_cont:
	loop	input_pre
input_pre_done:
	mov	[ctn], edx
	pop	edx
	xor	eax, eax
	mov	ecx, 256
	repnz	scasb
	jnz	pack_calltrick_fail
	not	cl
	mov	[cti], cl
@@:
	cmp	ebx, edx
	jz	@f
	sub	ebx, 4
	mov	eax, [ebx]
	mov	[eax-4], cl
	jmp	@b
@@:
	xor	ebx, ebx
	push	8000h
	push	ebx
	push	edx
	call	[VirtualFree]
	ret

pack_aplib:
	push	ebx
	push	[workmem]
	mov	eax, [insize]
	sub	eax, [indelta]
	push	eax
	mov	eax, [outfile]
	add	eax, 24h
	push	eax
	mov	eax, [infile]
	add	eax, [indelta]
	push	eax
	call	_aP_pack
	add	esp, 20
	ret
pack_lzma:
	push	[workmem]
	mov	eax, [insize]
	sub	eax, [indelta]
	push	eax
	mov	eax, [outfile]
	add	eax, 24h - 5
	push	eax
	mov	eax, [infile]
	add	eax, [indelta]
	push	eax
	call	lzma_compress
	mov	ecx, [outfile]
	mov	ecx, [ecx+20h]
	bswap	ecx
	mov	dword ptr [loader_lzma + 5], ecx
	sub	eax, 5
	ret

preprocess_calltrick2:
; restore input
	mov	esi, [infile]
	mov	ecx, [ctn]
	jecxz	pc2l2
pc2l1:
	lodsb
	sub	al, 0E8h
	cmp	al, 1
	ja	short pc2l1
	mov	al, [cti]
	cmp	[esi], al
	jnz	short pc2l1
	lodsd
	mov	al, 0
	bswap	eax
	sub	eax, esi
	add	eax, [infile]
	mov	[esi-4], eax
	loop	pc2l1
pc2l2:
; input preprocessing
	push	4	; PAGE_READWRITE
	push	1000h	; MEM_COMMIT
	push	[insize]
	push	ebx
	call	[VirtualAlloc]
	test	eax, eax
	jz	pack_calltrick_fail
	mov	edi, offset ct1
	xchg	eax, ebx
	xor	eax, eax
	push	edi
	mov	ecx, 256/4
	rep	stosd
	pop	edi
	mov	ecx, [insize]
	mov	esi, [infile]
	xchg	eax, edx
	push	ebx
input_pre2:
	lodsb
@@:
	cmp	al, 0Fh
	jnz	short ip1
	dec	ecx
	jz	short input_pre_done2
	lodsb
	cmp	al, 80h
	jb	short @b
	cmp	al, 90h
	jb	short @f
ip1:
	sub	al, 0E8h
	cmp	al, 1
	ja	short input_pre_cont2
@@:
	cmp	ecx, 5
	jb	short input_pre_done2
	lodsd
	add	eax, esi
	sub	eax, [infile]
	cmp	eax, [insize]
	jae	short xxx2
	cmp	eax, 1000000h
	jae	short xxx2
	sub	ecx, 4
	bswap	eax
	mov	[esi-4], eax
	inc	edx
	mov	[ebx], esi
	add	ebx, 4
	jmp	short input_pre_cont2
xxx2:	sub	esi, 4
	movzx	eax, byte ptr [esi]
	mov	byte ptr [eax+edi], 1
input_pre_cont2:
	loop	input_pre2
input_pre_done2:
	mov	[ctn], edx
	pop	edx
	xor	eax, eax
	mov	ecx, 256
	repnz	scasb
	jnz	pack_calltrick_fail
	not	cl
	mov	[cti], cl
@@:
	cmp	ebx, edx
	jz	@f
	sub	ebx, 4
	mov	eax, [ebx]
	mov	[eax-4], cl
	jmp	@b
@@:
	xor	ebx, ebx
	push	8000h
	push	ebx
	push	edx
	call	[VirtualFree]
	ret

	end	_start
